PF-build.sh 61 KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465666768697071727374757677787980818283848586878889909192939495969798991001011021031041051061071081091101111121131141151161171181191201211221231241251261271281291301311321331341351361371381391401411421431441451461471481491501511521531541551561571581591601611621631641651661671681691701711721731741751761771781791801811821831841851861871881891901911921931941951961971981992002012022032042052062072082092102112122132142152162172182192202212222232242252262272282292302312322332342352362372382392402412422432442452462472482492502512522532542552562572582592602612622632642652662672682692702712722732742752762772782792802812822832842852862872882892902912922932942952962972982993003013023033043053063073083093103113123133143153163173183193203213223233243253263273283293303313323333343353363373383393403413423433443453463473483493503513523533543553563573583593603613623633643653663673683693703713723733743753763773783793803813823833843853863873883893903913923933943953963973983994004014024034044054064074084094104114124134144154164174184194204214224234244254264274284294304314324334344354364374384394404414424434444454464474484494504514524534544554564574584594604614624634644654664674684694704714724734744754764774784794804814824834844854864874884894904914924934944954964974984995005015025035045055065075085095105115125135145155165175185195205215225235245255265275285295305315325335345355365375385395405415425435445455465475485495505515525535545555565575585595605615625635645655665675685695705715725735745755765775785795805815825835845855865875885895905915925935945955965975985996006016026036046056066076086096106116126136146156166176186196206216226236246256266276286296306316326336346356366376386396406416426436446456466476486496506516526536546556566576586596606616626636646656666676686696706716726736746756766776786796806816826836846856866876886896906916926936946956966976986997007017027037047057067077087097107117127137147157167177187197207217227237247257267277287297307317327337347357367377387397407417427437447457467477487497507517527537547557567577587597607617627637647657667677687697707717727737747757767777787797807817827837847857867877887897907917927937947957967977987998008018028038048058068078088098108118128138148158168178188198208218228238248258268278288298308318328338348358368378388398408418428438448458468478488498508518528538548558568578588598608618628638648658668678688698708718728738748758768778788798808818828838848858868878888898908918928938948958968978988999009019029039049059069079089099109119129139149159169179189199209219229239249259269279289299309319329339349359369379389399409419429439449459469479489499509519529539549559569579589599609619629639649659669679689699709719729739749759769779789799809819829839849859869879889899909919929939949959969979989991000100110021003100410051006100710081009101010111012101310141015101610171018101910201021102210231024102510261027102810291030103110321033103410351036103710381039104010411042104310441045104610471048104910501051105210531054105510561057105810591060106110621063106410651066106710681069107010711072107310741075107610771078107910801081108210831084108510861087108810891090109110921093109410951096109710981099110011011102110311041105110611071108110911101111111211131114111511161117111811191120112111221123112411251126112711281129113011311132113311341135113611371138113911401141114211431144114511461147114811491150115111521153115411551156115711581159116011611162116311641165116611671168116911701171117211731174117511761177117811791180118111821183118411851186118711881189119011911192119311941195119611971198119912001201120212031204120512061207120812091210121112121213
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.2.0-Build_53
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. # 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
  139. # 12 Feb 2021, 3d-gussner, Add MK404-build.sh
  140. # 13 Feb 2021, 3d-gussner, Indentations
  141. # 13 Feb 2021, 3d-gussner, MK404 improvements like "flash" MK3, MK3S languages files to MK404 xflash.
  142. # 27 Feb 2021, 3d-gussner, Add './lang-community.sh' and update exits
  143. # 03 May 2021, 3d-gussner, Update exit numbers
  144. # 01-14 prepare build env
  145. # 21-32 prepare compiling
  146. # 41-47 compiling
  147. # 51-54 cleanup
  148. # 61-62 MK404
  149. # 03 May 2021, 3d-gussner, Update documentation and change version to v1.2.0
  150. # 03 May 2021, 3d-gussner, Add SIM atmega404
  151. # 17 Jun 2021, 3d-gussner, Update PF-build.sh to work after DRracer Remove FW version parsing PR
  152. #### Start check if OSTYPE is supported
  153. OS_FOUND=$( command -v uname)
  154. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  155. linux*)
  156. TARGET_OS="linux"
  157. ;;
  158. msys*|cygwin*|mingw*)
  159. # or possible 'bash on windows'
  160. TARGET_OS='windows'
  161. ;;
  162. nt|win*)
  163. TARGET_OS='windows'
  164. ;;
  165. *)
  166. TARGET_OS='unknown'
  167. ;;
  168. esac
  169. # Windows
  170. if [ $TARGET_OS == "windows" ]; then
  171. if [ $(uname -m) == "x86_64" ]; then
  172. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  173. Processor="64"
  174. elif [ $(uname -m) == "i386" ]; then
  175. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  176. Processor="32"
  177. else
  178. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  179. echo "Please refer to the notes of build.sh$(tput sgr0)"
  180. exit 1
  181. fi
  182. # Linux
  183. elif [ $TARGET_OS == "linux" ]; then
  184. if [ $(uname -m) == "x86_64" ]; then
  185. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  186. Processor="64"
  187. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  188. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  189. Processor="32"
  190. else
  191. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  192. echo "Please refer to the notes of build.sh$(tput sgr0)"
  193. exit 1
  194. fi
  195. else
  196. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  197. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  198. echo "Read the notes of build.sh$(tput sgr0)"
  199. exit 1
  200. fi
  201. sleep 2
  202. #### End check if OSTYPE is supported
  203. #### Prepare bash environment and check if wget, zip and other needed things are available
  204. # Check wget
  205. if ! type wget > /dev/null; then
  206. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  207. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  208. exit 2
  209. fi
  210. # Check for zip
  211. if ! type zip > /dev/null; then
  212. if [ $TARGET_OS == "windows" ]; then
  213. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  214. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  215. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  216. echo "Run git Bash under Administrator privilege and"
  217. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  218. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  219. exit 3
  220. elif [ $TARGET_OS == "linux" ]; then
  221. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  222. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  223. #sudo apt-get update && apt-get install zip
  224. exit 3
  225. fi
  226. fi
  227. # Check python ... needed during language build
  228. if ! type python > /dev/null; then
  229. if [ $TARGET_OS == "windows" ]; then
  230. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  231. exit 4
  232. elif [ $TARGET_OS == "linux" ]; then
  233. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  234. echo "As Python 2.x will not be maintained from 2020 please,"
  235. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  236. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  237. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  238. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  239. exit 4
  240. fi
  241. fi
  242. # Check gawk ... needed during language build
  243. if ! type gawk > /dev/null; then
  244. if [ $TARGET_OS == "linux" ]; then
  245. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  246. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  247. #sudo apt-get update && apt-get install gawk
  248. exit 5
  249. fi
  250. fi
  251. #### End prepare bash / Linux environment
  252. # Check for options/flags
  253. while getopts b:c:d:f:g:h:i:l:m:n:o:p:v:x:?h flag
  254. do
  255. case "${flag}" in
  256. b) build_flag=${OPTARG};;
  257. c) clean_flag=${OPTARG};;
  258. d) devel_flag=${OPTARG};;
  259. f) board_flash_flag=${OPTARG};;
  260. g) graphics_flag=${OPTARG};;
  261. h) help_flag=1;;
  262. i) IDE_flag=${OPTARG};;
  263. l) language_flag=${OPTARG};;
  264. m) mk404_flag=${OPTARG};;
  265. n) new_build_flag=${OPTARG};;
  266. o) output_flag=${OPTARG};;
  267. p) prusa_flag=${OPTARG};;
  268. v) variant_flag=${OPTARG};;
  269. x) board_mem_flag=${OPTARG};;
  270. ?) help_flag=1;;
  271. esac
  272. done
  273. #
  274. # '?' 'h' argument usage and help
  275. if [ "$help_flag" == "1" ] ; then
  276. echo "***************************************"
  277. echo "* PF-build.sh Version: 1.2.0-Build_49 *"
  278. echo "***************************************"
  279. echo "Arguments:"
  280. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  281. echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build'$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  282. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  283. echo "$(tput setaf 2)-f$(tput sgr0) Board flash size '$(tput setaf 2)256$(tput sgr0)','$(tput setaf 2)384$(tput sgr0)','$(tput setaf 2)512$(tput sgr0)','$(tput setaf 2)1024$(tput sgr0)''$(tput setaf 2)32M$(tput sgr0)'"
  284. echo "$(tput setaf 2)-g$(tput sgr0) Start MK404 grafics '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' lite '$(tput setaf 2)2$(tput sgr0)' fancy"
  285. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  286. echo "$(tput setaf 2)-i$(tput sgr0) Arduino IDE version '$(tput setaf 2)1.8.5$(tput sgr0)', '$(tput setaf 2)1.8.13$(tput sgr0)'"
  287. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  288. echo "$(tput setaf 2)-m$(tput sgr0) Start MK404 sim '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes '$(tput setaf 2)2$(tput sgr0)' with MMU2"
  289. echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  290. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  291. echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  292. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  293. echo "$(tput setaf 2)-x$(tput sgr0) Board memory size '$(tput setaf 2)8$(tput sgr0)' or '$(tput setaf 2)64$(tput sgr0)' Kb."
  294. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  295. echo
  296. echo "Brief USAGE:"
  297. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-v] [-l] [-d] [-b] [-o] [-c] [-p] [-n]"
  298. echo
  299. echo "Example:"
  300. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  301. echo " Will build all variants as multi language and final GOLD version"
  302. echo
  303. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
  304. echo " Will build MK3S multi language final GOLD firmware "
  305. echo " with current commit count number and output extra information,"
  306. echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
  307. echo
  308. exit 6
  309. fi
  310. #Check if Build is selected with argument '-f'
  311. if [ ! -z "$board_flash_flag" ] ; then
  312. if [ "$board_flash_flag" == "256" ] ; then
  313. BOARD_FLASH="0x3FFFF"
  314. BOARD_maximum_size="253952"
  315. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  316. elif [ "$board_flash_flag" == "384" ] ; then
  317. BOARD_FLASH="0x5FFFF"
  318. BOARD_maximum_size="385024"
  319. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  320. elif [ "$board_flash_flag" == "512" ] ; then
  321. BOARD_FLASH="0x7FFFF"
  322. BOARD_maximum_size="516096"
  323. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  324. elif [ "$board_flash_flag" == "1024" ] ; then
  325. BOARD_FLASH="0xFFFFF"
  326. BOARD_maximum_size="1040384"
  327. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  328. elif [[ "$board_flash_flag" == "32M" || "$board_flash_flag" == "32768" ]] ; then
  329. BOARD_FLASH="0x1FFFFFF"
  330. BOARD_maximum_size="33546240"
  331. echo "Board flash size : 32 Mb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  332. else
  333. echo "Unsupported board flash size chosen. Only '256', '384', '512', '1024' and '32M' are allowed."
  334. exit 7
  335. fi
  336. fi
  337. #Check if Build is selected with argument '-x'
  338. if [ ! -z "$board_mem_flag" ] ; then
  339. if [ "$board_mem_flag" == "8" ] ; then
  340. BOARD_MEM="0x21FF"
  341. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  342. elif [ "$board_mem_flag" == "64" ] ; then
  343. BOARD_MEM="0xFFFF"
  344. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  345. else
  346. echo "Unsupported board mem size chosen. Only '8', '64' are allowed."
  347. exit 8
  348. fi
  349. fi
  350. #Check if Arduino IDE version is correct
  351. if [ ! -z "$IDE_flag" ]; then
  352. if [[ "$IDE_flag" == "1.8.5" || "$IDE_flag" == "1.8.13" ]]; then
  353. ARDUINO_ENV="${IDE_flag}"
  354. else
  355. ARDUINO_ENV="1.8.5"
  356. fi
  357. else
  358. ARDUINO_ENV="1.8.5"
  359. fi
  360. #### Set build environment
  361. BUILD_ENV="1.0.6"
  362. BOARD="prusa_einsy_rambo"
  363. BOARD_PACKAGE_NAME="PrusaResearch"
  364. BOARD_VERSION="1.0.3"
  365. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  366. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  367. BOARD_FILENAME="prusa3dboards"
  368. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  369. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  370. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  371. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  372. LIB="PrusaLibrary"
  373. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  374. # List few useful data
  375. echo
  376. echo "Script path :" $SCRIPT_PATH
  377. echo "OS :" $OS
  378. echo "OS type :" $TARGET_OS
  379. echo ""
  380. echo "Arduino IDE :" $ARDUINO_ENV
  381. echo "Build env :" $BUILD_ENV
  382. echo "Board :" $BOARD
  383. if [ ! -z "$BOARD_FLASH" ] ; then
  384. echo "Board flash :" $BOARD_FLASH
  385. fi
  386. if [ ! -z "$BOARD_MEM" ] ; then
  387. echo "Board mem :" $BOARD_MEM
  388. fi
  389. echo "Package name:" $BOARD_PACKAGE_NAME
  390. echo "Board v. :" $BOARD_VERSION
  391. echo "Specific Lib:" $LIB
  392. echo ""
  393. #### Start prepare building environment
  394. #Check if build exists and creates it if not
  395. if [ ! -d "../PF-build-dl" ]; then
  396. mkdir ../PF-build-dl || exit 9
  397. fi
  398. cd ../PF-build-dl || exit 10
  399. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  400. # Check if PF-build-env-<version> exists and downloads + creates it if not
  401. # The build environment is based on the supported Arduino IDE portable version with some changes
  402. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  403. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  404. mkdir ../PF-build-env-$BUILD_ENV
  405. sleep 5
  406. fi
  407. # Download and extract supported Arduino IDE depending on OS
  408. # Windows
  409. if [ $TARGET_OS == "windows" ]; then
  410. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  411. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  412. sleep 2
  413. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 8
  414. echo "$(tput sgr 0)"
  415. fi
  416. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  417. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  418. sleep 2
  419. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 9
  420. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  421. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  422. echo "$(tput sgr0)"
  423. fi
  424. fi
  425. # Linux
  426. if [ $TARGET_OS == "linux" ]; then
  427. # 32 or 64 bit version
  428. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  429. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  430. sleep 2
  431. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  432. echo "$(tput sgr 0)"
  433. fi
  434. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  435. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  436. sleep 2
  437. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 9
  438. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  439. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  440. echo "$(tput sgr0)"
  441. fi
  442. fi
  443. # Make Arduino IDE portable
  444. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  445. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  446. fi
  447. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  448. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  449. fi
  450. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  451. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  452. fi
  453. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  454. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  455. fi
  456. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  457. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  458. fi
  459. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  460. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  461. fi
  462. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  463. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  464. fi
  465. # Change Arduino IDE preferences
  466. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  467. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  468. sleep 2
  469. echo "update.check"
  470. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  471. echo "board"
  472. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  473. echo "editor.linenumbers"
  474. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  475. echo "boardsmanager.additional.urls"
  476. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  477. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  478. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  479. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  480. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  481. echo "$(tput sgr0)"
  482. fi
  483. # Download and extract Prusa Firmware related parts
  484. # Download and extract PrusaResearchRambo board
  485. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  486. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  487. sleep 2
  488. wget $BOARD_FILE_URL || exit 10
  489. fi
  490. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  491. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  492. sleep 2
  493. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 11
  494. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  495. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  496. fi
  497. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  498. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  499. fi
  500. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  501. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  502. fi
  503. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  504. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  505. fi
  506. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  507. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  508. echo "$(tput sgr 0)"
  509. fi
  510. # Download and extract Prusa Firmware specific library files
  511. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  512. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  513. sleep 2
  514. wget $PF_BUILD_FILE_URL || exit 12
  515. echo "$(tput sgr 0)"
  516. fi
  517. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  518. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  519. sleep 2
  520. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 13
  521. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  522. echo "$(tput sgr0)"
  523. fi
  524. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  525. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  526. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  527. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  528. sleep 2
  529. fi
  530. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  531. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  532. sleep 2
  533. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  534. sleep 2
  535. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  536. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  537. echo "$(tput sgr0)"
  538. fi
  539. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  540. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  541. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  542. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  543. sleep 2
  544. echo "$(tput sgr0)"
  545. exit 14
  546. fi
  547. #### End prepare building
  548. #### Start
  549. cd $SCRIPT_PATH
  550. # Check if git is available
  551. if type git > /dev/null; then
  552. git_available="1"
  553. fi
  554. #
  555. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  556. if [ -z "$variant_flag" ] ; then
  557. # Select which variant of the Prusa Firmware will be compiled, like
  558. PS3="Select a variant: "
  559. while IFS= read -r -d $'\0' f; do
  560. options[i++]="$f"
  561. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  562. select opt in "${options[@]}" "All" "Quit"; do
  563. case $opt in
  564. *.h)
  565. VARIANT=$(basename "$opt" ".h")
  566. VARIANTS[i++]="$opt"
  567. break
  568. ;;
  569. "All")
  570. VARIANT="All"
  571. VARIANTS=${options[*]}
  572. break
  573. ;;
  574. "Quit")
  575. echo "You chose to stop"
  576. exit 22
  577. ;;
  578. *)
  579. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  580. ;;
  581. esac
  582. done
  583. else
  584. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  585. VARIANTS=$variant_flag
  586. elif [ "$variant_flag" == "All" ] ; then
  587. while IFS= read -r -d $'\0' f; do
  588. options[i++]="$f"
  589. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  590. VARIANT="All"
  591. VARIANTS=${options[*]}
  592. else
  593. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  594. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  595. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  596. echo "$(tput sgr0)"
  597. exit 23
  598. fi
  599. fi
  600. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  601. #Check default language mode
  602. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  603. if [ -z "$language_flag" ] ; then
  604. PS3="Select a language: "
  605. echo
  606. echo "Which lang-build do you want?"
  607. select yn in "Multi languages" "English only"; do
  608. case $yn in
  609. "Multi languages")
  610. LANGUAGES="ALL"
  611. break
  612. ;;
  613. "English only")
  614. LANGUAGES="EN_ONLY"
  615. break
  616. ;;
  617. *)
  618. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  619. ;;
  620. esac
  621. done
  622. else
  623. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  624. LANGUAGES=$language_flag
  625. else
  626. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  627. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  628. exit 24
  629. fi
  630. fi
  631. #Check if DEV_STATUS is selected via argument '-d'
  632. if [ ! -z "$devel_flag" ] ; then
  633. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  634. DEV_STATUS_SELECTED=$devel_flag
  635. elif [[ "$devel_flag" == "atmega404" || "$devel_flag" == "atmega404_no_bootloader" ]] ; then
  636. MK404_DEBUG=$devel_flag
  637. else
  638. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  639. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  640. exit 25
  641. fi
  642. fi
  643. #Check if Build is selected via argument '-b'
  644. if [ ! -z "$build_flag" ] ; then
  645. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  646. echo "Build changed to $build_flag"
  647. BUILD=$(git rev-list --count HEAD)
  648. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  649. BUILD=$build_flag
  650. else
  651. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  652. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  653. exit 26
  654. fi
  655. echo "New Build number is: $BUILD"
  656. fi
  657. # check if script has been started with arguments
  658. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  659. OUTPUT=1
  660. else
  661. OUTPUT=0
  662. fi
  663. #echo "Output is:" $OUTPUT
  664. #Check git branch has changed
  665. if [ ! -z "git_available" ]; then
  666. BRANCH=""
  667. CLEAN_PF_FW_BUILD=0
  668. else
  669. BRANCH=$(git branch --show-current)
  670. echo "Current branch is:" $BRANCH
  671. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  672. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  673. echo "created PF-build.branch file"
  674. else
  675. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  676. echo "Previous branch was:" $PRE_BRANCH
  677. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  678. CLEAN_PF_FW_BUILD=1
  679. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  680. fi
  681. fi
  682. fi
  683. #Set BUILD_ENV_PATH
  684. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 27
  685. BUILD_ENV_PATH="$( pwd -P )"
  686. cd ../..
  687. #Checkif BUILD_PATH exists and if not creates it
  688. if [ ! -d "Prusa-Firmware-build" ]; then
  689. mkdir Prusa-Firmware-build || exit 28
  690. fi
  691. #Set the BUILD_PATH for Arduino IDE
  692. cd Prusa-Firmware-build || exit 29
  693. BUILD_PATH="$( pwd -P )"
  694. #Check git branch has changed
  695. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  696. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  697. rm -r *
  698. else
  699. echo "Nothing to clean up"
  700. fi
  701. for v in ${VARIANTS[*]}
  702. do
  703. VARIANT=$(basename "$v" ".h")
  704. MK404_PRINTER=$(grep --max-count=1 "\bPRINTER_TYPE\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3 | cut -d '_' -f2)
  705. # Find firmware version in Configuration.h file and use it to generate the hex filename
  706. FW_MAJOR=$(grep --max-count=1 "\bFW_MAJOR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  707. FW_MINOR=$(grep --max-count=1 "\bFW_MINOR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  708. FW_REVISION=$(grep --max-count=1 "\bFW_REVISION\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  709. FW="$FW_MAJOR$FW_MINOR$FW_REVISION"
  710. #FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  711. if [ -z "$BUILD" ] ; then
  712. # Find build version in Configuration.h file and use it to generate the hex filename
  713. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  714. else
  715. # Find and replace build version in Configuration.h file
  716. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  717. echo "Original build number: $BUILD_ORG"
  718. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  719. fi
  720. # Check if the motherboard is an EINSY and if so only one hex file will generated
  721. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  722. # Check development status
  723. FW_FLAV=$(grep --max-count=1 "//#define FW_FLAVOR\b" $SCRIPT_PATH/Firmware/Configuration.h|cut -d ' ' -f1)
  724. if [[ "$FW_FLAV" != "//#define" ]] ; then
  725. FW_FLAVOR=$(grep --max-count=1 "\bFW_FLAVOR\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  726. FW_FLAVERSION=$(grep --max-count=1 "\bFW_FLAVERSION\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  727. if [[ "$FW_FLAVOR" != "//#define FW_FLAVOR" ]] ; then
  728. FW="$FW-$FW_FLAVOR"
  729. DEV_CHECK="$FW_FLAVOR"
  730. if [ ! -z "$FW_FLAVERSION" ] ; then
  731. FW="$FW$FW_FLAVERSION"
  732. fi
  733. fi
  734. fi
  735. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  736. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  737. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  738. DEV_STATUS="RC"
  739. elif [[ "$DEV_CHECK" == *"ALPHA"* ]]; then
  740. DEV_STATUS="ALPHA"
  741. elif [[ "$DEV_CHECK" == *"BETA"* ]]; then
  742. DEV_STATUS="BETA"
  743. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  744. DEV_STATUS="DEVEL"
  745. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  746. DEV_STATUS="DEBUG"
  747. else
  748. DEV_STATUS="UNKNOWN"
  749. echo
  750. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  751. PS3="Select YES only if source code is tested and trusted: "
  752. select yn in "Yes" "No"; do
  753. case $yn in
  754. Yes)
  755. DEV_STATUS="GOLD"
  756. DEV_STATUS_SELECTED="GOLD"
  757. break
  758. ;;
  759. No)
  760. DEV_STATUS="UNKNOWN"
  761. DEV_STATUS_SELECTED="UNKNOWN"
  762. break
  763. ;;
  764. *)
  765. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  766. ;;
  767. esac
  768. done
  769. fi
  770. else
  771. DEV_STATUS=$DEV_STATUS_SELECTED
  772. fi
  773. #Prepare hex files folders
  774. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  775. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  776. fi
  777. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  778. if [ "$BOARD" != "prusa_einsy_rambo" ]; then
  779. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD" ]; then
  780. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD || exit 28
  781. fi
  782. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$BOARD"
  783. fi
  784. #Check if exactly the same hexfile already exists
  785. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  786. echo ""
  787. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  788. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  789. if [ $OUTPUT == "1" ] ; then
  790. read -t 10 -p "Press Enter to continue..."
  791. fi
  792. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  793. echo ""
  794. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  795. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  796. if [ $OUTPUT == "1" ] ; then
  797. read -t 10 -p "Press Enter to continue..."
  798. fi
  799. fi
  800. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  801. echo ""
  802. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  803. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  804. if [ $OUTPUT == "1" ] ; then
  805. read -t 10 -p "Press Enter to continue..."
  806. fi
  807. fi
  808. #List some useful data
  809. echo "$(tput setaf 2)$(tput setab 7) "
  810. echo "Printer :" $MK404_PRINTER
  811. echo "Variant :" $VARIANT
  812. echo "Firmware :" $FW
  813. echo "Build # :" $BUILD
  814. echo "Dev Check :" $DEV_CHECK
  815. echo "DEV Status :" $DEV_STATUS
  816. echo "Motherboard:" $MOTHERBOARD
  817. echo "Board flash:" $BOARD_FLASH
  818. echo "Board mem :" $BOARD_MEM
  819. echo "Languages :" $LANGUAGES
  820. echo "Hex-file Folder:" $OUTPUT_FOLDER
  821. echo "$(tput sgr0)"
  822. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  823. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  824. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  825. else
  826. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  827. if [ $OUTPUT == "1" ] ; then
  828. read -t 10 -p "Press Enter to continue..."
  829. fi
  830. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  831. fi
  832. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  833. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  834. # set FW_REPOSITORY
  835. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  836. #Prepare English only or multi-language version to be build
  837. if [ $LANGUAGES == "EN_ONLY" ]; then
  838. echo " "
  839. echo "English only language firmware will be built"
  840. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  841. echo " "
  842. else
  843. echo " "
  844. echo "Multi-language firmware will be built"
  845. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  846. echo " "
  847. fi
  848. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  849. #if [ $TARGET_OS == "windows" ]; then
  850. #RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  851. #fi
  852. #New fresh PF-Firmware-build
  853. if [ "$new_build_flag" == "1" ]; then
  854. rm -r -f $BUILD_PATH/* || exit 54
  855. fi
  856. # Prepare Board mem and flash modifications
  857. ## Check board mem size
  858. CURRENT_BOARD_MEM=$(grep "#define RAMEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  859. if [ $CURRENT_BOARD_MEM != "0x21FF" ] ; then
  860. echo "Board mem has been already modified or not reset"
  861. echo "Current:" $CURRENT_BOARD_MEM
  862. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  863. select yn in "Yes" "No"; do
  864. case $yn in
  865. Yes)
  866. echo "Resetting board mem size"
  867. sed -i -- "s/^#define RAMEND .*$/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  868. break
  869. ;;
  870. *)
  871. echo "Continuing with modified mem size"
  872. break
  873. ;;
  874. esac
  875. done
  876. fi
  877. ## Modify board mem size
  878. if [[ ! -z $BOARD_MEM && "$BOARD_MEM" != "0x21FF" ]] ; then
  879. echo "$(tput setaf 3)Modifying board memory size (hex):$(tput sgr 0)"
  880. echo "Old:" $CURRENT_BOARD_MEM
  881. echo "New:" $BOARD_MEM
  882. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  883. echo ""
  884. sed -i -- "s/^#define RAMEND 0x21FF/#define RAMEND ${BOARD_MEM}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  885. fi
  886. ## Check board flash size
  887. CURRENT_BOARD_FLASH=$(grep "#define FLASHEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  888. CURRENT_BOARD_maximum_size=$(grep "prusa_einsy_rambo.upload.maximum_size" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt |cut -d '=' -f2|tr -d $'\n')
  889. if [[ $CURRENT_BOARD_FLASH != "0x3FFFF" || $CURRENT_BOARD_maximum_size != "253952" ]] ; then
  890. echo "Board flash has been already modified or not reset"
  891. echo "Current flash size:" $CURRENT_BOARD_FLASH
  892. echo "Current max. size:" $CURRENT_BOARD_maximum_size
  893. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  894. select yn in "Yes" "No"; do
  895. case $yn in
  896. Yes)
  897. echo "$(tput setaf 1)Resetting board flash size$(tput sgr 0)"
  898. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  899. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  900. break
  901. ;;
  902. *)
  903. echo "$(tput setaf 3)Continuing with modified flash size$(tput sgr 0)"
  904. break
  905. ;;
  906. esac
  907. done
  908. fi
  909. ## Modify boad flash size
  910. if [[ ! -z $BOARD_FLASH && "$BOARD_FLASH" != "0x3FFFF" ]] ; then
  911. echo "Modifying board flash size (hex):"
  912. echo "Old flash size:" $CURRENT_BOARD_FLASH
  913. echo "New flash size:" $BOARD_FLASH
  914. echo "Old max. size:" $CURRENT_BOARD_maximum_size
  915. echo "New max. size:" $BOARD_maximum_size
  916. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  917. sed -i -- "s/^#define FLASHEND .*/#define FLASHEND ${BOARD_FLASH}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  918. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=${BOARD_maximum_size}/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  919. fi
  920. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  921. # if [ $TARGET_OS == "windows" ]; then
  922. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  923. # fi
  924. #### End of Prepare building
  925. #### Start building
  926. export ARDUINO=$BUILD_ENV_PATH
  927. #echo $BUILD_ENV_PATH
  928. #export BUILDER=$ARDUINO/arduino-builder
  929. echo
  930. #read -t 5 -p "Press Enter..."
  931. echo
  932. echo "Start to build Prusa Firmware ..."
  933. echo "Using variant $VARIANT$(tput setaf 3)"
  934. if [ $OUTPUT == "1" ] ; then
  935. sleep 2
  936. fi
  937. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 41
  938. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 42
  939. echo "$(tput sgr 0)"
  940. if [ $LANGUAGES == "ALL" ]; then
  941. echo "$(tput setaf 2)"
  942. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  943. echo "$(tput sgr 0)"
  944. if [ $OUTPUT == "1" ] ; then
  945. sleep 2
  946. fi
  947. cd $SCRIPT_PATH/lang
  948. echo "$(tput setaf 3)"
  949. ./config.sh || exit 43
  950. echo "$(tput sgr 0)"
  951. # Check if previous languages and firmware build exist and if so clean them up
  952. if [ -f "lang_en.tmp" ]; then
  953. echo ""
  954. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  955. if [ $OUTPUT == "1" ] ; then
  956. read -t 10 -p "Press Enter to continue..."
  957. fi
  958. echo "$(tput setaf 3)"
  959. ./lang-clean.sh
  960. echo "$(tput sgr 0)"
  961. fi
  962. if [ -f "progmem.out" ]; then
  963. echo ""
  964. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  965. if [ $OUTPUT == "1" ] ; then
  966. read -t 10 -p "Press Enter to continue..."
  967. fi
  968. echo "$(tput setaf 3)"
  969. ./fw-clean.sh
  970. echo "$(tput sgr 0)"
  971. fi
  972. # build languages
  973. echo "$(tput setaf 3)"
  974. ./lang-build.sh || exit 44
  975. # build community languages
  976. ./lang-community.sh || exit 45
  977. # Combine compiled firmware with languages
  978. ./fw-build.sh || exit 46
  979. cp not_tran.txt not_tran_$VARIANT.txt
  980. cp not_used.txt not_used_$VARIANT.txt
  981. echo "$(tput sgr 0)"
  982. # Check if the motherboard is an EINSY and if so only one hex file will generated
  983. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  984. # If the motherboard is an EINSY just copy one hexfile
  985. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  986. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  987. # Make a copy of "lang.bin" for MK404 MK3 and MK3S
  988. if [ ! -z "$mk404_flag" ]; then
  989. cp -f lang.bin $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin
  990. fi
  991. # End of "lang.bin" for MK3 and MK3S copy
  992. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  993. else
  994. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  995. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  996. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  997. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  998. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  999. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  1000. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  1001. cp -f firmware_nl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-nl.hex
  1002. if [ $TARGET_OS == "windows" ]; then
  1003. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1004. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1005. elif [ $TARGET_OS == "linux" ]; then
  1006. # Make a copy for MK404 sim of MK2, MK2.5, MK2.5S firmware
  1007. if [ ! -z "$mk404_flag" ]; then
  1008. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1009. fi
  1010. # End of MK2, MK2.5, MK2.5S firmware copy
  1011. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1012. fi
  1013. fi
  1014. # Cleanup after build
  1015. if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
  1016. echo "$(tput setaf 3)"
  1017. ./fw-clean.sh || exit 51
  1018. ./lang-clean.sh || exit 52
  1019. echo "$(tput sgr 0)"
  1020. fi
  1021. else
  1022. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  1023. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 47
  1024. fi
  1025. # Cleanup Firmware
  1026. if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
  1027. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 53
  1028. fi
  1029. # Delete dupblicates
  1030. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  1031. then
  1032. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  1033. fi
  1034. # MK2 not supported in this branch
  1035. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  1036. then
  1037. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  1038. fi
  1039. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  1040. then
  1041. rm $SCRIPT_PATH/lang/not_tran.txt
  1042. fi
  1043. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  1044. then
  1045. rm $SCRIPT_PATH/lang/not_used.txt
  1046. fi
  1047. #New fresh PF-Firmware-build
  1048. if [ "$new_build_flag" == "1" ]; then
  1049. rm -r -f $BUILD_PATH/* || exit 54
  1050. fi
  1051. # Restore files to previous state
  1052. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  1053. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  1054. if [ ! -z "$BUILD_ORG" ] ; then
  1055. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  1056. fi
  1057. echo $MULTI_LANGUAGE_CHECK
  1058. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  1059. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1060. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1061. if [ $OUTPUT == "1" ] ; then
  1062. sleep 5
  1063. fi
  1064. # Restore build env files to previous state
  1065. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1066. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  1067. sed -i -- "s/^#define RAMEND.*/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1068. done
  1069. # Switch to hex path and list build files
  1070. cd $SCRIPT_PATH
  1071. echo "$(tput setaf 2) "
  1072. echo " "
  1073. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  1074. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  1075. #### End building
  1076. #### MK404 Simulator
  1077. # Check/compile MK404 sim
  1078. if [ ! -z "$mk404_flag" ]; then
  1079. ./MK404-build.sh -c1 || exit 61
  1080. # For Prusa MK2, MK2.5/S
  1081. if [ "$MOTHERBOARD" == "BOARD_RAMBO_MINI_1_3" ]; then
  1082. MK404_PRINTER="${MK404_PRINTER}_mR13"
  1083. else
  1084. if [[ "$mk404_flag" == "2" || "$mk404_flag" == "MMU2" || "$mk404_flag" == "MMU2S" ]]; then # Check if MMU2 is selected only for MK3/S
  1085. MK404_PRINTER="${MK404_PRINTER}MMU2"
  1086. fi
  1087. fi
  1088. # Run MK404 with 'debugcore' and/or 'bootloader-file'
  1089. echo "MK404_DEBUG --$MK404_DEBUG--"
  1090. if [ "$MK404_DEBUG" == "atmega404" ]; then
  1091. MK404_options="--debugcore"
  1092. elif [ "$MK404_DEBUG" == "atmega404_no_bootloader" ]; then
  1093. MK404_options='--debugcore --bootloader-file ""'
  1094. fi
  1095. # Run MK404 with grafics
  1096. if [ ! -z "$graphics_flag" ]; then
  1097. echo "MK404_options --$MK404_options--"
  1098. if [ ! -z "$MK404_options" ]; then
  1099. MK404_options="${MK404_options} --colour-extrusion --extrusion Quad_HR -g "
  1100. else
  1101. MK404_options="--colour-extrusion --extrusion Quad_HR -g "
  1102. fi
  1103. if [[ "$graphics_flag" == "1" || "$graphics_flag" == "lite" ]]; then
  1104. MK404_options="${MK404_options}lite"
  1105. elif [[ "$graphics_flag" == "2" || "$graphics_flag" == "fancy" ]]; then
  1106. MK404_options="${MK404_options}fancy"
  1107. else
  1108. echo "$(tput setaf 1)Unsupported MK404 graphics option $graphics_flag$(tput sgr 0)"
  1109. fi
  1110. fi
  1111. # Output some useful data
  1112. echo "Printer: $MK404_PRINTER"
  1113. echo "Options: $MK404_options"
  1114. # Change to MK404 build folder
  1115. cd ../MK404/master/build
  1116. # Copy language bin file for MK3 and MK3S to xflash
  1117. # if [ -f $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin ]; then
  1118. # echo "Copy 'FW$FW-Build$BUILD-$VARIANT-lang.bin' to 'Prusa_${MK404_PRINTER}_xflash.bin'"
  1119. # dd if=/dev/zero bs=1 count=262145 | tr "\000" "\377" >Prusa_${MK404_PRINTER}_xflash.bin
  1120. # dd if=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin of=Prusa_${MK404_PRINTER}_xflash.bin conv=notrunc
  1121. # fi
  1122. #Decide which hex file to use EN_ONLY or Multi language
  1123. if [ "$LANGUAGES" == "ALL" ]; then
  1124. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1125. else
  1126. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex
  1127. fi
  1128. # Start MK404
  1129. # default with serial output and terminal to manipulate it via terminal
  1130. ./MK404 Prusa_$MK404_PRINTER -s --terminal $MK404_options -f $MK404_firmware_file || exit 62
  1131. fi
  1132. #### End of MK404 Simulator